//
// meibo.cpp - after
//
#include <iostream>
#include <fstream>
#include <vector>
#include <string>

using namespace std;

#define FILENAME "meibo.dat"

class Member {
    string _name;
    string _email;
public:
    Member() {}
    Member(string name, string email) {
        _name = name;
        _email = email;
    }
    ~Member() {};

    const string getName(){ 
        return _name; 
    }
    const string getEmail(){ 
        return _email; 
    }

    friend ostream& operator<<(ostream& os, Member & m);
};

ostream& operator<<(ostream& os, Member & m)
{
    os << m.getName().c_str() << ':' << m.getEmail().c_str();
    return os;
}

vector <Member> member;

// o^
int regist()
{
    string name, email;
    cout << "Name:";
    cin >> name;
    cout << "E-Mail:";
    cin >> email;

    Member m(name, email);
    member.push_back(m);

    return member.size();
}

// Xg`ŕ\
void disp()
{    
    for (int i = 0; i < (int)member.size(); i++)
        cout << member[i] << endl;
}

void find()
{
    // f[^Ȃ̓^[
    if (member.size() < 1)
        return;

    string name;
    cout << "Name:";
    cin >> name;
    int pos = -1;
    for (int i=0; i < (int)member.size(); i++)
    {
        if (member[i].getName().compare(name) ==0)
        {
            pos = i;
            break;
        }
    }
    if (pos == -1)
        cout << "Not find!" << endl;
    else
        cout << member[pos] << endl;
}

int load()
{    
    ifstream fs;

    // t@CJ
    fs.open(FILENAME);

    // t@C݂Ȃꍇ̏
   if (!fs.is_open())
    {
        cout << FILENAME << "J܂B" << endl;
        return 0;
    }

    member.clear();  // Reiɂ

    while(!fs.eof())
    {
        string name, email;
        fs >> name;
        fs >> email;
        if (name.length() > 1 && email.length() > 1) 
        {
            Member m(name, email);
            member.push_back(m);
        }
    }

    fs.close();
    return member.size();
}

void save()
{   
    // f[^Ȃ̓^[
    if (member.size() < 1)
        return ;

    ofstream fs;
    fs.open(FILENAME);
    if (!fs.is_open())
    {
        cout << FILENAME << "J܂B" << endl;
        return;
    }

    for (int i=0; i < (int)member.size(); i++)
    {
        fs << member[i].getName() << endl;
        fs << member[i].getEmail() << endl;
    }
    fs.close();
}

int main()
{
    string command;
    
    while (1) {
        // R}h\
        cout << "regist, disp, find, load, save, quit" << endl << "=>";
        cin >> command;
        if (command.compare("regist") == 0)
            regist();
        if (command.compare("disp")==0)
            disp();
        if (command.compare("find")==0)
            find();
        if (command.compare("load")==0)
            load();
        if (command.compare("save")==0)
            save();
        if (command.compare("quit")==0)
            break;
    }

    return 0;
}
