//
// mpvssp.cpp
//
#include <iostream>
#include <ctime>
#include <cmath>
#include <iomanip>
#include <omp.h>

// 敪ϖ@  ̋ߎl߂B
// openMPo[W
void openMPVersion()
{
    const int DivNum = 1000 * 1000 * 1000;
    const double delta = 1.0 / DivNum;
    double sum = 0;

#pragma omp parallel for reduction(+ : sum)
    for (int i = 0; i < DivNum; ++i)
    {
        const double x = (delta * i);
        const double area = delta *  1.0 / (x * x + 1.0);
        sum += area;
    }
     const double pi = sum * 4.0;

    std::cout << std::setprecision(15) << "PI ~= " << pi << std::endl;
}

// 敪ϖ@  ̋ߎl߂B
// VOXbho[W
void singleVersion()
{
    const int DivNum = 1000 * 1000 * 1000;
    const double delta = 1.0 / DivNum;
    double sum = 0;

    for (int i = 0; i < DivNum; ++i)
    {
        const double x = (delta * i);
        const double area = delta *  1.0 / (x * x + 1.0);
        sum += area;
    }
     const double pi = sum * 4.0;

    std::cout << std::setprecision(15) << "PI ~= " << pi << std::endl;
}

int main()
{

    time_t t;
    clock_t start, end;

    start = clock();    // X^[g
    singleVersion();
    end = clock();     // I
    std::cout << "single Version=" << (end - start) << std::endl;

    std::cout << "OpenMP̍őXbh=" << 
        omp_get_max_threads() << std::endl;
    start = clock();    // X^[g
    openMPVersion();
    end = clock();     // I
    std::cout << "openMP Version=" << (end - start) << std::endl;

    return 0;
}
